<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Bezier</title>
    <script type="module">
        import { LitElement, svg, css, html } from 'https://unpkg.com/lit-element/lit-element.js?module';
    
        class Bezier extends LitElement
        {
            static get properties()
            {
                return {
                    ps: { type: Object },
                    pe: { type: Object },
                    dp: { type: Object }
                }
            }

            constructor()
            {
                super();
                this.ps = {
                    x: 100,
                    y: 100
                };
                this.pe = {
                    x: 400,
                    y: 400
                };
                this.pd = {
                    x: 250,
                    y: 250
                };


                this.moving = false;
                this.addEventListener('mousedown', e => {
                    this.moving = true;
                    console.log("mousedown");
                });
                this.addEventListener('mouseup', e => {
                    this.moving = false;
                    console.log("mouseup");
                });
                this.addEventListener('mousemove', event => {
                    if ( this.moving ){
                        this.pd.x = event.x;
                        this.pd.y = event.y;
                        super.update();
                        console.log("mousemove");
                    }
                });
            }

            render()
            {
                return svg`
                    <svg width="100%" height="500">
                        <path fill="white" stroke="black" stroke-width="3" d="M${this.ps.x +","+this.ps.y} C${this.ps.x +","+this.ps.y} ${this.pd.x +","+this.pd.y} ${this.pe.x +","+this.pe.y}"></path>
                        <circle r="5" stroke="black" stroke-width="1" fill="black" cx="${this.ps.x}" cy="${this.ps.y}"></circle>
                        <circle style="cursor: move;" r="40" stroke="black" stroke-width="1" fill="white" cx="${this.pd.x}" cy="${this.pd.y}"></circle>
                        <circle r="5" stroke="black" stroke-width="1" fill="black" cx="${this.pe.x}" cy="${this.pe.y}"></circle>
                        <line
                            x1="${this.ps.x}"
                            y1="${this.ps.y}"
                            x2="${this.pd.x}"
                            y2="${this.pd.y}"
                            stroke="gray"
                            stroke-width="2">
                        </line>
                        <line
                            x1="${this.pd.x}"
                            y1="${this.pd.y}"
                            x2="${this.pe.x}"
                            y2="${this.pe.y}"
                            stroke="gray"
                            stroke-width="2">
                        </line>
                    </svg>
                    `;
            }
        }


        customElements.define('bezier-base', Bezier)
        var bezier = document.createElement('bezier-base');
        document.querySelector('body').appendChild(bezier);
    </script>
</head>
<body>        
</body>
</html>